<?php
/**
 * Enter description here ...
 *
 * @package Logic
 *
 * @author  alessandrobartels
 */
class MsgCalculo {

    private static $instance = null;

    private $nrcalculofolha;
    private $nrvinculom;
    private $nrorg;
    private $mensagens;
    private $idstatus;
    private $idabort;

    /*Tipos de mensagens*/
    const ERRO = 'E';
    const ALERTA = 'A';

    /*Status do MsgCalculo*/
    const ID_PENDENTE = 0;
    const ID_COM_ALERTA = 1;
    const ID_COM_ERRO = 2;
    const ID_CONCLUIDO = 3;

    private function __construct() {
        $this->mensagens = array();
        $this->idstatus = self::ID_PENDENTE;
        $this->idabort = false;
    }

    private function __clone() {

    }

    public static function getInstance() {
        if (self::$instance === null) {
            self::$instance = new self();
        }

        return self::$instance;
    }

    public function clear()
    {
        self::$instance = null;
    }

    public function setDados($nrcalculofolha, $nrvinculom, $nrorg)
    {
        $this->nrcalculofolha = $nrcalculofolha;
        $this->nrvinculom = $nrvinculom;
        $this->nrorg = $nrorg;
    }

    public function getDados()
    {
        return array(
            'NRCALCULOFOLHA' => $this->nrcalculofolha,
            'NRVINCULOM' => $this->nrvinculom,
            'NRORG' => $this->nrorg,
            'MENSAGENS' => $this->mensagens,
            'IDSTATUS' => $this->idstatus,
            'IDABORT' => $this->idabort,
        );
    }

    public function adicionaMensagem($mensagem, $tipo = self::ERRO, $abort = false)
    {
        $this->mensagens[] = array(
            'MENSAGEM' => $mensagem,
            'TIPO' => $tipo
        );

        if ($tipo === self::ERRO) {
            $this->idstatus = self::ID_COM_ERRO;
        }
        elseif ($tipo === self::ALERTA) {
            if ($this->idstatus != self::ID_COM_ERRO) {
                $this->idstatus = self::ID_COM_ALERTA;
            }
        }

        $this->idabort = $abort === true ? $abort : $this->idabort;
    }

    public function retornaMensagens($tipo = null)
    {
        $result = array();

        if ($tipo === null) {
            $result = $this->mensagens;
        }
        else {
            foreach ($this->mensagens as $index => $msg) {
                if ($msg['TIPO'] === $tipo) {
                    $result[] = $this->mensagens[$index];
                }
            }
        }

        return $result;
    }

    public function salvaMensagens()
    {
        try {

            \Folha\Repositories\FpaMsgcalculo::limpaMsgCalculoVinculo($this->nrcalculofolha, $this->nrvinculom, $this->nrorg);

            foreach ($this->mensagens as $mensagem) {
                //$msg.=$mensagem['MENSAGEM'].'<br>';

                $msgCalculo = new \Folha\Entities\FpaMsgcalculo();
                $nrmsgcalc = \Geral\Util\NovoCodigo::geraCodigo($this->nrorg, "FPA_MSGCALCULO", 1, 1, true, false);

                $msgCalculo->setNrmsgcalc($nrmsgcalc);
                $msgCalculo->setNrcalculofolha($this->nrcalculofolha);
                $msgCalculo->setNrvinculom($this->nrvinculom);
                $msgCalculo->setDescricao($mensagem['MENSAGEM']);
                $msgCalculo->setIdtipomsg($mensagem['TIPO']);
                $msgCalculo->setNrorg($this->nrorg);
                $msgCalculo->setCdoperinclusao(\Geral\Util\Ambiente::getCdOperador());
                $msgCalculo->setNrorginclusao($this->nrorg);

                //@todo Salvar e exibir mensagens de alerta
                if($mensagem['TIPO']===self::ERRO){
                    $msgCalculo->persist();
                }
            }

            \Setforms2\Shared\Registry::getEntityManager()->flush();
        } catch (Exception $e) {
            tk_warning('Erro ao cadastrar mensagem de cálculo [Vínculo:' . $this->nrvinculom . ' / Erro:' . $e->getMessage() . ']');
            return null;
        }
    }
}