/* Tabela PRODUTOSEG: */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes
na tabela PRODUTOSEG */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Item do PRODUTOSEG,
utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_PARAMCTBL
AFTER DELETE OR INSERT OR UPDATE
ON PARAMCTBL FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(1000);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';
   IF DELETING THEN
      IF :OLD.NRPARAMCTBL IS NOT NULL THEN
         V_DESC := V_DESC || 'NumParam=' || :OLD.NRPARAMCTBL;
      END IF;

      IF :OLD.CDCONTFORN IS NOT NULL THEN
         V_DESC := V_DESC || ' Forn=' || :OLD.CDCONTFORN;
      END IF;

      IF :OLD.CDCONTCLIE IS NOT NULL THEN
         V_DESC := V_DESC || ' Cliente=' || :OLD.CDCONTCLIE;
      END IF;

      IF :OLD.DTINTCTBBCO IS NOT NULL THEN
         V_DESC := V_DESC || ' ContrBanc=' || :OLD.DTINTCTBBCO;
      END IF;

      IF :OLD.DTINTCTBDFE IS NOT NULL THEN
         V_DESC := V_DESC || ' DocFiscaisEntr=' || :OLD.DTINTCTBDFE;
      END IF;

      IF :OLD.DTINTCTBDFS IS NOT NULL THEN
         V_DESC := V_DESC || ' DocFiscaisSaida=' || :OLD.DTINTCTBDFS;
      END IF;

      IF :OLD.DTINTCTBEST IS NOT NULL THEN
         V_DESC := V_DESC || ' Estoque=' || :OLD.DTINTCTBEST;
      END IF;

      IF :OLD.DTINTCTBEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' Expedicao=' || :OLD.DTINTCTBEXP;
      END IF;

      IF :OLD.DTINTCTBFAC IS NOT NULL THEN
         V_DESC := V_DESC || ' FatComissaria=' || :OLD.DTINTCTBFAC;
      END IF;

      IF :OLD.DTINTCTBFAI IS NOT NULL THEN
         V_DESC := V_DESC || ' FatAliIndust=' || :OLD.DTINTCTBFAI;
      END IF;

      IF :OLD.DTINTCTBFAS IS NOT NULL THEN
         V_DESC := V_DESC || ' FatServico=' || :OLD.DTINTCTBFAS;
      END IF;

      IF :OLD.DTINTCTBFIS IS NOT NULL THEN
         V_DESC := V_DESC || ' Fiscal=' || :OLD.DTINTCTBFIS;
      END IF;

      IF :OLD.DTINTCTBPAG IS NOT NULL THEN
         V_DESC := V_DESC || ' Conta Pag=' || :OLD.DTINTCTBPAG;
      END IF;

      IF :OLD.DTINTCTBREC IS NOT NULL THEN
         V_DESC := V_DESC || ' Conta Rec=' || :OLD.DTINTCTBREC;
      END IF;

      IF :OLD.DTINTCTBPDV IS NOT NULL THEN
         V_DESC := V_DESC || ' Ponto de Venda=' || :OLD.DTINTCTBPDV;
      END IF;

      IF :OLD.DTINTCTBACA IS NOT NULL THEN
         V_DESC := V_DESC || ' Academico=' || :OLD.DTINTCTBACA;
      END IF;

      IF :OLD.IDCALCSALINT IS NOT NULL THEN
         V_DESC := V_DESC || ' Atualiz de Saldo=' || :OLD.IDCALCSALINT;
      END IF;

      IF :OLD.CDCONTDIFE IS NOT NULL THEN
         V_DESC := V_DESC || ' Vendas diferidas=' || :OLD.CDCONTDIFE;
      END IF;

      IF :OLD.CDCTBLPERDPA IS NOT NULL THEN
         V_DESC := V_DESC || ' Lucros e Vendas=' || :OLD.CDCTBLPERDPA;
      END IF;

      IF :OLD.CDCONTDITEN IS NOT NULL THEN
         V_DESC := V_DESC || ' Entrada=' || :OLD.CDCONTDITEN;
      END IF;

      IF :OLD.CDCONTDITSA IS NOT NULL THEN
         V_DESC := V_DESC || ' Saida=' || :OLD.CDCONTDITSA;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.NRPARAMCTBL;
/*      V_CDFILLOGOPER := :OLD.CDFILIAL; */
   ELSE
      IF UPDATING THEN
         IF (:OLD.NRPARAMCTBL  <> :NEW.NRPARAMCTBL)  OR
            (NVL(:OLD.CDCONTFORN,'!')   <> NVL(:NEW.CDCONTFORN,'!'))   OR
            (NVL(:OLD.CDCONTCLIE,'!')   <> NVL(:NEW.CDCONTCLIE,'!'))   OR
            (NVL(:OLD.DTINTCTBBCO,SYSDATE)  <> NVL(:NEW.DTINTCTBBCO,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBDFE,SYSDATE)  <> NVL(:NEW.DTINTCTBDFE,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBDFS,SYSDATE)  <> NVL(:NEW.DTINTCTBDFS,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBEST,SYSDATE)  <> NVL(:NEW.DTINTCTBEST,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBEXP,SYSDATE)  <> NVL(:NEW.DTINTCTBEXP,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBFAC,SYSDATE)  <> NVL(:NEW.DTINTCTBFAC,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBFAI,SYSDATE)  <> NVL(:NEW.DTINTCTBFAI,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBFAS,SYSDATE)  <> NVL(:NEW.DTINTCTBFAS,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBFIS,SYSDATE)  <> NVL(:NEW.DTINTCTBFIS,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBPAG,SYSDATE)  <> NVL(:NEW.DTINTCTBPAG,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBREC,SYSDATE)  <> NVL(:NEW.DTINTCTBREC,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBPDV,SYSDATE)  <> NVL(:NEW.DTINTCTBPDV,SYSDATE))  OR
            (NVL(:OLD.DTINTCTBACA,SYSDATE)  <> NVL(:NEW.DTINTCTBACA,SYSDATE))  OR
            (NVL(:OLD.IDCALCSALINT,'!') <> NVL(:NEW.IDCALCSALINT,'!')) OR
            (NVL(:OLD.CDCONTDIFE,'!')   <> NVL(:NEW.CDCONTDIFE,'!'))   OR
            (NVL(:OLD.CDCTBLPERDPA,'!') <> NVL(:NEW.CDCTBLPERDPA,'!')) OR
            (NVL(:OLD.CDCONTDITEN,'!')  <> NVL(:NEW.CDCONTDITEN,'!'))  OR
            (NVL(:OLD.CDCONTDITSA,'!')  <> NVL(:NEW.CDCONTDITSA,'!'))  THEN

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.NRPARAMCTBL;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.NRPARAMCTBL;
      END IF;
      IF :NEW.NRPARAMCTBL IS NOT NULL THEN
         V_DESC := V_DESC || 'NumParam=' || :NEW.NRPARAMCTBL;
      END IF;

      IF NVL(:OLD.CDCONTFORN,'!')   <> NVL(:NEW.CDCONTFORN,'!') THEN
         V_DESC := V_DESC || ' Forn=' || :NEW.CDCONTFORN;
      END IF;

      IF NVL(:OLD.CDCONTCLIE,'!')   <> NVL(:NEW.CDCONTCLIE,'!') THEN
         V_DESC := V_DESC || ' Cliente=' || :NEW.CDCONTCLIE;
      END IF;

      IF NVL(:OLD.DTINTCTBBCO,SYSDATE)  <> NVL(:NEW.DTINTCTBBCO,SYSDATE) THEN
         V_DESC := V_DESC || ' ContrBanc=' || :NEW.DTINTCTBBCO;
      END IF;

      IF NVL(:OLD.DTINTCTBDFE,SYSDATE)  <> NVL(:NEW.DTINTCTBDFE,SYSDATE)THEN
         V_DESC := V_DESC || ' DocFiscaisEntr=' || :NEW.DTINTCTBDFE;
      END IF;

      IF NVL(:OLD.DTINTCTBDFS,SYSDATE)  <> NVL(:NEW.DTINTCTBDFS,SYSDATE)THEN
         V_DESC := V_DESC || ' DocFiscaisSaida=' || :NEW.DTINTCTBDFS;
      END IF;

      IF NVL(:OLD.DTINTCTBEST,SYSDATE)  <> NVL(:NEW.DTINTCTBEST,SYSDATE) THEN
         V_DESC := V_DESC || ' Estoque=' || :NEW.DTINTCTBEST;
      END IF;

      IF NVL(:OLD.DTINTCTBEXP,SYSDATE)  <> NVL(:NEW.DTINTCTBEXP,SYSDATE) THEN
         V_DESC := V_DESC || ' Expedicao=' || :NEW.DTINTCTBEXP;
      END IF;

      IF NVL(:OLD.DTINTCTBFAC,SYSDATE)  <> NVL(:NEW.DTINTCTBFAC,SYSDATE) THEN
         V_DESC := V_DESC || ' FatComissaria=' || :NEW.DTINTCTBFAC;
      END IF;

      IF NVL(:OLD.DTINTCTBFAI,SYSDATE)  <> NVL(:NEW.DTINTCTBFAI,SYSDATE)  THEN
         V_DESC := V_DESC || ' FatAliIndust=' || :NEW.DTINTCTBFAI;
      END IF;

      IF NVL(:OLD.DTINTCTBFAS ,SYSDATE)  <> NVL(:NEW.DTINTCTBFAS ,SYSDATE) THEN
         V_DESC := V_DESC || ' FatServico=' || :NEW.DTINTCTBFAS;
      END IF;

      IF NVL(:OLD.DTINTCTBFIS ,SYSDATE)  <> NVL(:NEW.DTINTCTBFIS ,SYSDATE) THEN
         V_DESC := V_DESC || ' Fiscal=' || :NEW.DTINTCTBFIS;
      END IF;

      IF NVL(:OLD.DTINTCTBPAG ,SYSDATE)  <> NVL(:NEW.DTINTCTBPAG ,SYSDATE) THEN
         V_DESC := V_DESC || ' Conta Pag=' || :NEW.DTINTCTBPAG;
      END IF;

      IF NVL(:OLD.DTINTCTBREC,SYSDATE)  <> NVL(:NEW.DTINTCTBREC,SYSDATE) THEN
         V_DESC := V_DESC || ' Conta Rec=' || :NEW.DTINTCTBREC;
      END IF;

      IF NVL(:OLD.DTINTCTBPDV,SYSDATE)  <> NVL(:NEW.DTINTCTBPDV,SYSDATE) THEN
         V_DESC := V_DESC || ' Ponto de Venda=' || :NEW.DTINTCTBPDV;
      END IF;

      IF NVL(:OLD.DTINTCTBACA ,SYSDATE)  <> NVL(:NEW.DTINTCTBACA ,SYSDATE)THEN
         V_DESC := V_DESC || ' Academico=' || :NEW.DTINTCTBACA;
      END IF;

      IF NVL(:OLD.IDCALCSALINT,'!')  <> NVL(:NEW.IDCALCSALINT ,'!') THEN
         V_DESC := V_DESC || ' Atualiz de Saldo=' || :NEW.IDCALCSALINT;
      END IF;

      IF NVL(:OLD.CDCONTDIFE,'!')  <> NVL(:NEW.CDCONTDIFE ,'!') THEN
         V_DESC := V_DESC || ' Vendas diferidas=' || :NEW.CDCONTDIFE;
      END IF;

      IF NVL(:OLD.CDCTBLPERDPA,'!')  <> NVL(:NEW.CDCTBLPERDPA ,'!') THEN
         V_DESC := V_DESC || ' Lucros e Vendas=' || :NEW.CDCTBLPERDPA;
      END IF;

      IF NVL(:OLD.CDCONTDITEN,'!')  <> NVL(:NEW.CDCONTDITEN,'!') THEN
         V_DESC := V_DESC || ' Entrada=' || :NEW.CDCONTDITEN;
      END IF;

      IF NVL(:OLD.CDCONTDITSA,'!')  <> NVL(:NEW.CDCONTDITSA,'!') THEN
         V_DESC := V_DESC || ' Saida=' || :NEW.CDCONTDITSA;
      END IF;

   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('PARAMCTBL',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, SUBSTR(V_DESC, 1, 300), V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_PARAMCTBL','5.05.018'); END;
/
