/* Tabela PRODLOJA: TABELA DE PRODUTO POR LOJA */
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela PRODLOJA*/
/* Objetivo: Gerar um log que vai registrar as alteraes na PRODLOJA,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_PRODLOJA
AFTER DELETE OR INSERT OR UPDATE
ON PRODLOJA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      
	  IF NVL(:NEW.CDFILIAL,'NULL') <> NVL(:OLD.CDFILIAL,'NULL') THEN 
         V_DESC := 'Filial ' || '' || NVL(:NEW.CDFILIAL,'' );
      END IF;
      IF NVL(:NEW.CDLOJA,'NULL') <> NVL(:OLD.CDLOJA,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Loja ' || '' || NVL(:NEW.CDLOJA,''  );
      END IF;
	  IF NVL(:NEW.CDPRODUTO,'NULL') <> NVL(:OLD.CDPRODUTO,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Produto ' || '' || NVL(:NEW.CDPRODUTO,'' );
      END IF;
	  IF NVL(:NEW.DSENDIMPPROD,'NULL') <> NVL(:OLD.DSENDIMPPROD,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'End Port Impre ' || '' || NVL(:NEW.DSENDIMPPROD,'' );
      END IF;
	  IF NVL(:NEW.CDPORIMPPROD,'NULL') <> NVL(:OLD.CDPORIMPPROD,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Cd Port Impre ' || '' || NVL(:NEW.CDPORIMPPROD,''  );
      END IF;
	  IF NVL(:NEW.CDTIPIMPPROD,'NULL') <> NVL(:OLD.CDTIPIMPPROD,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Cd Yp impresso ' || '' || NVL(:NEW.CDTIPIMPPROD,''  );
      END IF;
	  IF NVL(:NEW.DTULTATUPLOJ,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTULTATUPLOJ,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Dt Ult Atu Registro ' || '' || NVL(:NEW.DTULTATUPLOJ,'');
      END IF;
	  IF NVL(:NEW.IDIMPCANITEM,'NULL') <> NVL(:OLD.IDIMPCANITEM,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Id Imp Cancelada ' || '' || NVL(:NEW.IDIMPCANITEM,'');
      END IF;  
	  IF NVL(:NEW.CDSETOR,'NULL') <> NVL(:OLD.CDSETOR,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Cd Setor ' || '' || NVL(:NEW.CDSETOR,'');
      END IF;
	  IF NVL(:NEW.NRSEQIMPRPROD,'NULL') <> NVL(:OLD.NRSEQIMPRPROD,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Nr Sequencia Imp Prod ' || '' || NVL(:NEW.NRSEQIMPRPROD,'');
      END IF;
	  IF NVL(:NEW.NRSEQIMPRPUXA,'NULL') <> NVL(:OLD.NRSEQIMPRPUXA,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Nr Sequencia Imp Puxa ' || '' || NVL(:NEW.NRSEQIMPRPUXA,'');
      END IF;
	  
      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDLOJA||:NEW.CDPRODUTO;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Filial '               || '' || NVL(:NEW.CDFILIAL,''    )   || ' ' ||
                  'Loja  '                || '' || NVL(:NEW.CDLOJA,''  )       || ' ' ||
                  'Produto '              || '' || NVL(:NEW.CDPRODUTO,'' )     || ' ' ||
                  'End Port Impre  '      || '' || NVL(:NEW.DSENDIMPPROD,'' )  || ' ' ||
                  'Cd Port Impre  '       || '' || NVL(:NEW.CDPORIMPPROD,''  ) || ' ' ||
                  'Cd Yp impresso '      || '' || NVL(:NEW.CDTIPIMPPROD,''  ) || ' ' ||
                  'Dt Ult Atu Registro '  || '' || NVL(:NEW.DTULTATUPLOJ,'')   || ' ' ||
                  'Id Imp Cancelada '     || '' || NVL(:NEW.IDIMPCANITEM,'')   || ' ' ||
                  'Cd Setor '             || '' || NVL(:NEW.CDSETOR,'')        || ' ' ||
                  'Nr Sequencia Imp Prod '|| '' || NVL(:NEW.NRSEQIMPRPROD,'')  || ' ' ||
                  'Nr Sequencia Imp Puxa '|| '' || NVL(:NEW.NRSEQIMPRPUXA,'');

      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDLOJA||:NEW.CDPRODUTO;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Filial '               || '' || NVL(:OLD.CDFILIAL,''    )   || ' ' ||
                  'Loja  '                || '' || NVL(:OLD.CDLOJA,''  )       || ' ' ||
                  'Produto '              || '' || NVL(:OLD.CDPRODUTO,'' )     || ' ' ||
                  'End Port Impre  '      || '' || NVL(:OLD.DSENDIMPPROD,'' )  || ' ' ||
                  'Cd Port Impre  '       || '' || NVL(:OLD.CDPORIMPPROD,''  ) || ' ' ||
                  'Cd Yp impresso '      || '' || NVL(:OLD.CDTIPIMPPROD,''  ) || ' ' ||
                  'Dt Ult Atu Registro '  || '' || NVL(:OLD.DTULTATUPLOJ,'')   || ' ' ||
                  'Id Imp Cancelada '     || '' || NVL(:OLD.IDIMPCANITEM,'')   || ' ' ||
                  'Cd Setor '             || '' || NVL(:OLD.CDSETOR,'')        || ' ' ||
                  'Nr Sequencia Imp Prod '|| '' || NVL(:OLD.NRSEQIMPRPROD,'')  || ' ' ||
                  'Nr Sequencia Imp Puxa '|| '' || NVL(:OLD.NRSEQIMPRPUXA,'');

            V_ITPESQ := :OLD.CDFILIAL||:OLD.CDLOJA||:OLD.CDPRODUTO;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND,
       CDFILLOGOPERVND)
   VALUES
      ('PRODLOJA',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_PRODLOJA','5.20.001'); END;
/
